build: Make build more autotools-like.
[mes.git] / build-aux / check-mescc.sh
1 #! /bin/sh
2
3 # GNU Mes --- Maxwell Equations of Software
4 # Copyright © 2017,2018 Jan (janneke) Nieuwenhuizen <janneke@gnu.org>
5 #
6 # This file is part of GNU Mes.
7 #
8 # GNU Mes is free software; you can redistribute it and/or modify it
9 # under the terms of the GNU General Public License as published by
10 # the Free Software Foundation; either version 3 of the License, or (at
11 # your option) any later version.
12 #
13 # GNU Mes is distributed in the hope that it will be useful, but
14 # WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with GNU Mes.  If not, see <http://www.gnu.org/licenses/>.
20
21 set -e
22 . ${srcdest}build-aux/config.sh
23 . ${srcdest}build-aux/trace.sh
24
25 MES=${MES-src/mes}
26 [ -z "$MESCC" ] && MESCC=scripts/mescc
27 GUILE=${GUILE-guile}
28 MES_PREFIX=${MES_PREFIX-mes}
29
30 HEX2=${HEX2-hex2}
31 M1=${M1-M1}
32 BLOOD_ELF=${BLOOD_ELF-blood-elf}
33 MES_SEED=${MES_SEED-../mes-seed}
34 MESCC=${MESCC-$(command -v mescc)}
35 [ -z "$MESCC" ] && MESCC=scripts/mescc
36 MES=${MES-$(command -v mes)}
37 [ -z "$MES" ] && MES=src/mes
38
39 if ! command -v $GUILE > /dev/null; then
40     GUILE=true
41 fi
42
43 tests="
44 t
45 00-exit-0
46 01-return-0
47 02-return-1
48 03-call
49 04-call-0
50 05-call-1
51 06-call-!1
52 10-if-0
53 11-if-1
54 12-if-==
55 13-if-!=
56 14-if-goto
57 15-if-!f
58 16-if-t
59 20-while
60 21-char[]
61 22-while-char[]
62 23-pointer
63 30-strlen
64 31-eputs
65 32-compare
66 33-and-or
67 34-pre-post
68 35-compare-char
69 36-compare-arithmetic
70 37-compare-assign
71 38-compare-call
72 40-if-else
73 41-?
74 42-goto-label
75 43-for-do-while
76 44-switch
77 45-void-call
78 46-function-static
79 47-function-expression
80 48-function-destruct
81 49-global-static
82 4a-char-array
83 50-assert
84 51-strcmp
85 52-itoa
86 53-strcpy
87 54-argv
88 60-math
89 61-array
90 62-array
91 63-struct-cell
92 64-make-cell
93 65-read
94 70-printf
95 71-struct-array
96 72-typedef-struct-def
97 73-union
98 74-multi-line-string
99 75-struct-union
100 76-pointer-arithmetic
101 77-pointer-assign
102 78-union-struct
103 79-int-array
104 7a-struct-char-array
105 7b-struct-int-array
106 7c-dynarray
107 7d-cast-char
108 7e-struct-array-access
109 7f-struct-pointer-arithmetic
110 7g-struct-byte-word-field
111 7h-struct-assign
112 7i-struct-struct
113 7j-strtoull
114 7k-for-each-elem
115 7l-struct-any-size-array
116 7m-struct-char-array-assign
117 7n-struct-struct-array
118 7o-struct-pre-post
119 7p-struct-cast
120 7q-bit-field
121 7r-sign-extend
122 7s-struct-short
123 80-setjmp
124 81-qsort
125 82-define
126 83-heterogenoous-init
127 84-struct-field-list
128 85-sizeof
129 86-strncpy
130 87-sscanf
131 88-strrchr
132 90-strpbrk
133 91-fseek
134 92-stat
135 93-fread-fwrite
136 94-unsetenv
137 95-signal
138 96-strto
139 97-fopen
140 98-fopen
141 "
142
143 # 90: needs GNU, fails for mescc, passes for tcc
144 broken="$broken
145 7s-struct-short
146 "
147
148 # gcc not supported
149 CC=
150 set +e
151 expect=$(echo $broken | wc -w)
152 pass=0
153 fail=0
154 total=0
155 mkdir -p scaffold/tests
156 for t in $tests; do
157     if [ -z "${t/[012][0-9]-*/}" ]; then
158         LIBC=c-mini
159         MES_LIBS="-l c-mini"
160     elif [ -z "${t/[78][0-9a-z]-*/}" ]; then
161         LIBC=c+tcc
162         MES_LIBS="-l c+tcc"
163     elif [ -z "${t/9[0-9]-*/}" ]; then
164         LIBC=c+gnu
165         MES_LIBS="-l c+gnu"
166     else
167         LIBC=c
168         MES_LIBS=
169     fi
170     sh ${srcdest}build-aux/test.sh "scaffold/tests/$t" &> scaffold/tests/"$t".log
171     r=$?
172     total=$((total+1))
173     if [ $r = 0 ]; then
174         echo $t: [OK]
175         pass=$((pass+1))
176     else
177         echo $t: [FAIL]
178         fail=$((fail+1))
179     fi
180 done
181
182 tests="
183 00_assignment
184 01_comment
185 02_printf
186 03_struct
187 04_for
188 05_array
189 06_case
190 07_function
191 08_while
192 09_do_while
193
194 10_pointer
195 11_precedence
196 12_hashdefine
197 13_integer_literals
198 14_if
199 15_recursion
200 16_nesting
201 17_enum
202 18_include
203 19_pointer_arithmetic
204
205 20_pointer_comparison
206 21_char_array
207 22_floating_point
208 23_type_coercion
209 24_math_library
210 25_quicksort
211 26_character_constants
212 27_sizeof
213 28_strings
214 29_array_address
215
216 30_hanoi
217 31_args
218 32_led
219 33_ternary_op
220 34_array_assignment
221 35_sizeof
222 36_array_initialisers
223 37_sprintf
224 38_multiple_array_index
225 39_typedef
226
227 40_stdio
228 41_hashif
229 42_function_pointer
230 43_void_param
231 44_scoped_declarations
232 45_empty_for
233 47_switch_return
234 48_nested_break
235 49_bracket_evaluation
236
237 50_logical_second_arg
238 51_static
239 52_unnamed_enum
240 54_goto
241 55_lshift_type
242 "
243
244 broken="$broken
245 18_include
246
247 22_floating_point
248 23_type_coercion
249 24_math_library
250 26_character_constants
251 27_sizeof
252 28_strings
253
254 34_array_assignment
255 39_typedef
256
257 40_stdio
258 42_function_pointer
259 49_bracket_evaluation
260 55_lshift_type
261 "
262
263 #22_floating_point       ; float
264 #23_type_coercion        ; float
265 #24_math_library         ; float
266 #27_sizeof               ; float
267 #28_strings              ; TODO: strncpy strchr strrchr memset memcpy memcmp
268 #30_hanoi                ; fails with GCC
269 #34_array_assignment     ; fails with GCC
270 #39_typedef              ;unsupported: (decl (decl-spec-list (stor-spec (typedef)) (type-spec (typename "MyFunStruct"))) (init-declr-list (init-declr (ptr-declr (pointer) (ident "MoreFunThanEver")))))
271
272 #40_stdio                ; f* functions
273 #42_function_pointer     ; f* functions
274 #49_bracket_evaluation   ; float
275
276
277 LIBC=c+gnu
278 MES_LIBS="-l c+gnu"
279
280 expect=$(echo $broken | wc -w)
281 ARGS="arg1 arg2 arg3 arg4 arg5"
282 export ARGS
283 mkdir -p scaffold/tinycc
284 for t in $tests; do
285     if [ ! -f scaffold/tinycc/"$t.c" ]; then
286         echo ' [SKIP]'
287         continue;
288     fi
289     sh ${srcdest}build-aux/test.sh "scaffold/tinycc/$t" &> scaffold/tinycc/"$t".log
290     r=$?
291     total=$((total+1))
292     if [ $r = 0 ]; then
293         echo $t: [OK]
294         pass=$((pass+1))
295     else
296         echo $t: [FAIL]
297         fail=$((fail+1))
298     fi
299 done
300 [ $expect != 0 ] && echo "expect: $expect"
301 [ $fail != 0 ] && echo "failed: $fail"
302 [ $fail -lt $expect ] && echo "solved: $(($expect - $fail))"
303 echo "passed: $pass"
304 echo "total:  $total"
305 if [ $fail != 0 -a $fail -gt $expect ]; then
306     echo FAILED: $fail/$total
307     exit 1
308 elif [ $fail != 0 ]; then
309     echo PASS: $pass/$total
310 else
311     echo PASS: $total
312 fi